unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset, sqldb, FileUtil, Forms, Controls, Graphics,
  Dialogs, DBGrids, ExtCtrls, ActnList, Menus;

type

  { TForm1 }

  TForm1 = class(TForm)
    ActionEdit: TAction;
    ActionShowSelected: TAction;
    ActionList1: TActionList;
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    MenuEdit: TMenuItem;
    MenuShowSelected: TMenuItem;
    PopupMenu1: TPopupMenu;
    procedure ActionEditExecute(Sender: TObject);
    procedure ActionShowSelectedExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    procedure DBGrid1Paint(Sender: TObject);
    procedure UpdateMyActions;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  BufDataset1.CreateDataset;
  for i := 0 to 9 do begin
    BufDataset1.Insert;
    BufDataset1.Fields[0].AsString := 'Item' + IntToStr(i);
  end;
  BufDataset1.Active := True;
  DBGrid1.OnPaint  := @DBGrid1Paint;
end;

procedure TForm1.DBGrid1Paint(Sender: TObject);
begin
  UpdateMyActions;
end;

procedure TForm1.UpdateMyActions;
begin
  if DBGrid1.SelectedRows.Count > 1 then
  begin
    ActionEdit.Enabled := False;
    ActionShowSelected.Enabled := True;
  end else begin
    ActionEdit.Enabled := True;
    ActionShowSelected.Enabled := True;
  end;
end;

procedure TForm1.ActionEditExecute(Sender: TObject);
begin
  if DBGrid1.SelectedRows.Count > 0 then
    BufDataset1.GotoBookmark(DBGrid1.SelectedRows[0]);
  BufDataset1.Edit;
  BufDataset1.Fields[0].AsString := InputBox('Edit Field', '', BufDataset1.Fields[0].AsString);
end;

procedure TForm1.ActionShowSelectedExecute(Sender: TObject);
var
  s: String;
  i: Integer;
begin
  s := 'Selected:';
  for i := 0 to DBGrid1.SelectedRows.Count - 1 do
  begin
    BufDataset1.GotoBookmark(DBGrid1.SelectedRows[i]);
    s := s + LineEnding + BufDataset1.Fields[0].AsString;
  end;
  ShowMessage(s);
end;

end.

